// a blur shader with linear fading
// by marius schebella 02/2009
// I looked at http://buza.mitplw.com/blog/?p=159 and 
// the blur.frag by cyrille henry to write this

// don't know whether this is really needed, I leave it in:
#extension GL_ARB_texture_rectangle : enable	

// variables settable by Pd
uniform float horizontal; 
uniform float vertical;

// some helper variables
float xpos;
float ypos;
float maxhv;
float sum;

// texture comes from Pd
uniform sampler2DRect image;

vec2 pos = gl_TexCoord[0].st;

void main()
{
	vec4 color = texture2DRect(image, pos);
	sum = 1.;
	maxhv = max(horizontal, vertical);
	for (float i=0.; i<=horizontal*2.; i++) {
		xpos = i-horizontal;
		for (float j=0.; j<=vertical*2.; j++) {
			ypos = j-vertical;
			color += texture2DRect(image, pos+vec2( xpos, ypos)) * ((maxhv+1.)-sqrt(xpos*xpos+ypos*ypos));
			sum+=(maxhv+1.)-sqrt(xpos*xpos+ypos*ypos);
		}
	}
	gl_FragColor = color/sum;
}